#include <gtk/gtk.h>
#include "iface.h"

class gtk: public iface {
private:
	friend int gtk_refresh_function(gtk *);

	bool quit;
	bool configured;
	bool thread_running;

	// inter-thread communication :>
	bool masked;
	bool configure;

	char * question;
	char * reply;

	char *text[3];

	// refresher thread data
	GtkWidget *win, *lbl1, *lbl2, *status, *qbox;
	GtkProgress ** progress;
	GtkLabel ** transfer;
	GtkLabel ** eta;

	void init_window();

public:
	int main_pid;
	bool exiting;

	void destroy_window(){ gtk_widget_destroy(win); thread_running=false; }

	gtk(int * ac, char *** av);
	
	void eatkey();
	void msg(int l,char *fmt,...);
	void updateinfo(thread * th, int);
	void get_str(char * prompt, char * buf, int n, bool pass=false);
	
	bool setup(char * &host, char * &file);
	virtual ~gtk();
};
