#include <sys/types.h>
#include <sys/sendfile.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>

/***/

#define STRTOUL(a)	strtoul(a, &ep, 10); if(*ep){	\
	fprintf(stderr, "Error parsing integer: %s\n", ep); return 1; }

#define min(a,b)	(((a)>(b))?(b):(a))

int main(int ac, char ** av)
{
unsigned long start,len;
char * ep;
int fd;
char * buf;
	if(ac!=4){
	fprintf(stderr, "Usage: %s file start len\n", av[0]);
	return 1;
	}

start=	STRTOUL(av[2]);
len=	STRTOUL(av[3]);

fd=open(av[1], O_RDONLY);
	if(fd < 0){
	perror("open");
	return 1;
	}

	if(sendfile(1, fd, &start, len) == len) return 0;

	if(errno != ENOSYS){
	perror("sendfile");
	return 1;
	}

lseek(fd, start, SEEK_SET);
buf=malloc(4096);
	if(!buf){
	fprintf(stderr, "Can't allocate buffer!\n");
	return 1;
	}
	
	while(len>0){
	int l;
	l=read(fd, buf, min(sizeof(buf),len));
		if(l<0){
		perror("read");
		return 1;
		}
	len-=l;
	write(1, buf, l);
	}

return 0;
}
